/*
	File:		put.h

	Contains:	This is a set of formatting routines for use by dcmds.

	Version:	6.5.x

	Copyright:	 1988, 1997 by Apple Computer, Inc., all rights reserved.

	File Ownership:

		DRI:				Jim Murphy

		Other Contact:		Dave Lyons

		Technology:			MacsBug

	Writers:

		(JL)	Jim Luther
		(JM3)	Jim Murphy
		(sad)	Scott Douglass

	Change History (most recent first):

		 <3>	11/12/97	JL		Added PutMemoryLine.
		 <2>	 10/1/97	JM3		Removed the unimplemented PutInit. Updated PutPStrTruncTo,
									PutPStrTo, PutPStr to require ConstStr255Params so as to be more
									correct. Changed a bunch of stuff to UInt16 or UInt32. Shouldn't
									be noticed by anyone.
*/


#ifndef __put__
#define __put__

void PutLine();
void PutChar(char c);
void PutSpace();
void PutSpacesTo(int pos);
void PutBytesTruncTo(const char* s, int len, int endpos);
void PutBytesTo(const char* s, int len, int endpos);
void PutCStrTruncTo(const char* s, int endpos);
void PutCStrTo(const char* s, int endpos);
void PutCStr(const char* s);
void PutPStrTruncTo(ConstStr255Param s, int endpos);
void PutPStrTo(ConstStr255Param s, int endpos);
void PutPStr(ConstStr255Param s);
void PutUHexZTo(UInt32 i, int nz, int pos);
void PutUHexZ(UInt32 i, int nz);
void PutUHexWord(UInt16 h);
void PutUDecTo(UInt32 i, int endpos);
void PutUDec(UInt32 i);
void PutOSType(UInt32 typ);
void PutMemoryLine(Ptr address);

#endif
