/*
	File:		GWorldTools.h

	Contains:	API for GworldTools library.
	
	Written by:	Richard Clark

	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

			8/15/94		BLS		added Lib_Export pragmas for 68K builds.
			
	To Do:
*/

#ifndef __QUICKDRAW__
	#include <Quickdraw.h>
#endif

#ifndef __WINDOWS__
	#include <Windows.h>
#endif

#ifndef __QDOFFSCREEN__
	#include <QDOffscreen.h>
#endif

enum {
	// Custom result codes for CopyBufferToWindow
	kPixelsPurged = 1
	};

#ifdef __CFM68K__
#pragma lib_export on
#endif

Rect GetGlobalBounds (WindowPtr wp);
OSErr AllocateBuffer (WindowPtr wp, Rect bounds, GWorldPtr *buffer, Boolean disposeOld);
OSErr LockBuffer (GWorldPtr buffer, GWorldFlags *oldPixState);
OSErr UnlockBuffer (GWorldPtr buffer, GWorldFlags oldPixState);
OSErr UpdateBuffer (WindowPtr wp, GWorldPtr* buffer);
OSErr DisposeBuffer (GWorldPtr* buffer);
OSErr CopyBufferToWindow (WindowPtr wp, GWorldPtr buffer);

#ifdef __CFM68K__
#pragma lib_export off
#endif

