/*---------------------------------------------------------------------------*
 |                                                                           |
 |                    <<< PSets.h - Pascal set routines >>>                  |
 |                                                                           |
 *---------------------------------------------------------------------------*/

/* This file contains:

	
*/

#ifndef __PSETS__
#define __PSETS__

#ifndef __TYPES__
#include <Types.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned char PSet_Set8;
typedef unsigned short PSet_Set16;
typedef unsigned long PSet_Set32;
typedef unsigned short PSet_BigSet;

extern void PSet_Init(unsigned short *theSet, short nbrWords);
extern void PSet_Set(unsigned short *theSet, short nbrWords, unsigned long theElem);
extern void PSet_SetRange(unsigned short *theSet, short nbrWords, unsigned long elem1, unsigned long elem2);
extern Boolean PSet_Test(unsigned short *theSet, short nbrWords, unsigned long theElem);
extern Boolean PSet_Eq(unsigned short *set1, unsigned short *set2, short nbrWords);
extern Boolean PSet_Subset(unsigned short *set1, unsigned short *set2, short nbrWords);
extern Boolean PSet_Subset2(unsigned long set1, unsigned long set2);
extern unsigned short *PSet_Difference(unsigned short *dest, unsigned short *set1, unsigned short *set2, short nbrWords);
extern unsigned short *PSet_Intersection(unsigned short *dest, unsigned short *set1, unsigned short *set2, short nbrWords);
extern unsigned short *PSet_Union(unsigned short *dest, unsigned short *set1, unsigned short *set2, short nbrWords);


#ifdef __cplusplus
}
#endif

#endif
